#include "dialog.h"
#include "ui_dialog.h"
#include <QAxObject>
#include <QMessageBox>
#include <QFileDialog>
#include <vector>
#include <string>
#include <sstream>
using namespace std;

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
}

Dialog::~Dialog()
{
    delete ui;
}

void Dialog::on_b_einlesen_clicked()
{
    // Datei-Auswahlfenster anzeigen...
    QString fileName = QFileDialog::getOpenFileName(0, "Daten laden", "", "*.xls *.xlsx");
    if(fileName.isEmpty()) return;

    // Verbindung zu Excel herstellen, Datei öffnen...
    QAxObject excel;
    excel.setControl("Excel.Application");
    excel.setProperty("Visible", false);

    QAxObject *workbooks = excel.querySubObject("Workbooks");
    workbooks->dynamicCall("Open(QString)", fileName);

    QAxObject *active = excel.querySubObject("ActiveSheet");
    if(active == NULL) return;

    // Daten aus der ersten Spalte des Tabellenblatts lesen...
    vector<double> daten;
    int zeile = 1;
    QAxObject *cell = active->querySubObject("Cells(int,int)", zeile, 1);
    QVariant wert = cell->property("Value");
    while(!wert.isNull())
    {
        daten.push_back(wert.toDouble()); ++zeile;
        cell = active->querySubObject("Cells(int,int)", zeile, 1);
        wert = cell->property("Value");
    }
    excel.dynamicCall("Quit(void)");

    //////////////////////////////////
    // TODO: Daten auswerten...
    //////////////////////////////////

    ostringstream strm;
    for(auto x : daten)
    {
        strm << x << endl;
    }

    QMessageBox msg;
    msg.setText(strm.str().c_str());
    msg.exec();
}














